package board;

import java.awt.event.*;
import java.awt.*;
import java.util.*;

public abstract class ToolPanel
{

	// ʕ\[`
	abstract public void paint_main(Graphics g);
	
	// Ƃ̏
	abstract public void close();
	
	// }EXCxg
	abstract public void mousePressed_content(MouseEvent e);
	abstract public void mouseDragged_content(MouseEvent e);
	abstract public void mouseReleased_content(MouseEvent e);
	
	
	
	
	
	
	
	
	
	
	
	
	
	public static Color TOOL_BASE_COLOR =new Color(248, 245, 150, 240);
	
	public DrawPanel drawPanel;
	public Rectangle bbox;
	public Rectangle content_bbox;
	public String title = "";
	
	public ToolPanel(){
	}
	public void open(DrawPanel drawPanel, Point p){
		open(drawPanel, new Rectangle(p.x-100, p.y-50, 200, 100));
	}
	public void open(DrawPanel drawPanel, Rectangle bbox){
		this.drawPanel = drawPanel;
		this.bbox = bbox;
		
		if (bbox.x < 0) bbox.x = 0;
		if (bbox.y < 0) bbox.y = 0;
		if (bbox.x + bbox.width > drawPanel.getSize().width)
			bbox.x = drawPanel.getSize().width - bbox.width;
		if (bbox.y + bbox.height > drawPanel.getSize().height)
			bbox.y = drawPanel.getSize().height - bbox.height;
		

		update_bbox();		
		
		background_image = null;
	}
	
	public void update_bbox(){
		top_bbox = new Rectangle(bbox.x+1, bbox.y+1, bbox.width-2, TOP_H);
		content_bbox = new Rectangle(bbox.x+2,bbox.y+TOP_H+2,bbox.width-4, bbox.height-4-TOP_H);
	}
	
	Image background_image;
	Image buffered_image;
	
	static public final int TOP_H = 16;
	
	Rectangle top_bbox;
	
	boolean repaint_all;
	
	public void paint(Graphics g){
		if (background_image == null){
			prepare_background_image();
		}
		
		Rectangle rbbox = bbox;
		if (repaint_all){
			//rbbox = drawPanel.view.bbox_large;	
			rbbox = new Rectangle(0,0, drawPanel.getWidth(), drawPanel.getHeight());
			repaint_all = false;
		}
		
		Graphics2D bg = (Graphics2D) buffered_image.getGraphics();
		bg.drawImage(background_image, rbbox.x, rbbox.y, rbbox.x+rbbox.width, rbbox.y+rbbox.height, //0,0, bbox.width, bbox.height, 
										rbbox.x, rbbox.y, rbbox.x+rbbox.width, rbbox.y+rbbox.height,
									   null);
		
		bg.setColor(Color.gray);
		bg.draw3DRect(bbox.x, bbox.y, bbox.width-1, bbox.height-1,true);
		bg.draw3DRect(bbox.x+1,bbox.y+TOP_H+1,bbox.width-3, bbox.height-3-TOP_H,false);
		bg.fillRect(bbox.x+1, bbox.y+1, bbox.width-2, TOP_H);
		
		bg.setColor(Color.black);
		bg.drawString(title, bbox.x+10, bbox.y+13);
		
		bg.setColor(TOOL_BASE_COLOR);
		bg.fillRect(bbox.x+2,bbox.y+TOP_H+2,bbox.width-4, bbox.height-4-TOP_H);
		
		
		bg.setClip(content_bbox);
		bg.translate(content_bbox.x, content_bbox.y);
		
		bg.setStroke(DrawPanel.basicStroke);
		paint_main(bg);
		
		bg.dispose();
		
		g.drawImage(buffered_image, rbbox.x, rbbox.y, rbbox.x+rbbox.width, rbbox.y+rbbox.height,
									rbbox.x, rbbox.y, rbbox.x+rbbox.width, rbbox.y+rbbox.height,//0,0, bbox.width, bbox.height,
									 null);
	
	
	}
	public void prepare_background_image(){
		Dimension size = drawPanel.getSize();
		background_image = drawPanel.createImage(size.width, size.height);
		Graphics g = background_image.getGraphics();
		g.drawImage(drawPanel.buffered_image, 0,0, null);
		g.dispose();

		//buffered_image = drawPanel.createImage(bbox.width, bbox.height);
		buffered_image = drawPanel.createImage(size.width, size.height);
		
	
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	Point prev_p;
	public void start_dragging(Point p){
		prev_p = p;
	}
	public void dragging(Point p){
		Point dv = new Point(p.x-prev_p.x, p.y-prev_p.y);
		bbox.x += dv.x;
		bbox.y += dv.y;
		
		update_bbox();		

		prev_p = p;
		
		repaint_all = true;
	}
	public void finish_dragging(){
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	int operation_status;
	final int NONE = 0;
	final int DRAGGING = 1;
	final int CONTENT = 2;
	
	public void mousePressed(MouseEvent e){
		Point p = e.getPoint();
		if (!bbox.contains(p)){
			close();	
			drawPanel.toolPanel = null;
			drawPanel.repaint_all();
		}
		else if (top_bbox.contains(p)){
			start_dragging(p);
			operation_status = DRAGGING;	
		}
		else {
			mousePressed_content(convert(e));
			operation_status = CONTENT;	
		}
		
		
		
	}
	public void mouseDragged(MouseEvent e){
		Point p = e.getPoint();
		
		switch(operation_status){
		case DRAGGING:
			dragging(p);
			break;
		case CONTENT:
			mouseDragged_content(convert(e));
			break;
		}
	}
	public void mouseReleased(MouseEvent e){
		switch(operation_status){
		case DRAGGING:
			finish_dragging();
			break;
		case CONTENT:
			mouseReleased_content(convert(e));
			break;
		}
		
	}
	public MouseEvent convert(MouseEvent e){
		return new MouseEvent(e.getComponent(), e.getID(), e.getWhen(), e.getModifiers(), 
						   e.getX()-content_bbox.x, 
						   e.getY()-content_bbox.y, 
						   e.getClickCount(), false);		
	}
	
}
