package board;

import java.util.*;
import java.awt.*;
import java.io.*;


public class ToolSelector
{
	Vector tools = new Vector();
	
	Rectangle[] bboxs;

	Point position;
	boolean active = false;
	
	public void loadToolPanels(){
		
		// Get list of ToolPanels.
		java.io.File path = new java.io.File(".\\tools\\");
		String[] files = path.list( new ToolPanelFileFilter() );
		
		try {
			for( int i = 0; i < files.length; i++ ){
				Class c = Class.forName( "tools."+files[i].substring(0, files[i].length()-6) );
				ToolPanel toolPanel = (ToolPanel) (c.newInstance());
				tools.addElement(toolPanel);
				System.out.println("loading "+c);
			}
		} catch ( Exception e ){
			System.out.println(""+e);
        }			
		
	}
	public class ToolPanelFileFilter implements FilenameFilter {
		public boolean accept(File dir, String name){
			if( name.endsWith(".class" ) && name.substring(1,name.length()-6).endsWith("Panel") )
				return true;
			return false;
		}

	}
	
	
	
	
	
	
	
	
	
	
	ToolSelector(){
		loadToolPanels();
	}
	public void activate(Point p){
		position = p;
		active = true;
	}
	
	public void paint(Graphics g){
		bboxs = new Rectangle[tools.size()];

		for(int i=0; i<tools.size(); i++){
			ToolPanel tool = (ToolPanel) tools.elementAt(i);
			int x = position.x;
			int y = position.y + i* 20;
			
			
			Rectangle rect = new Rectangle(x, y, 160, 20);
			bboxs[i] = rect;
			
			g.setColor(new Color(255,255,255,128));
			g.fillRect(rect.x, rect.y, rect.width, rect.height);
			
			g.setColor(Color.black);
			g.drawRect(rect.x, rect.y, rect.width, rect.height);
			g.drawString(tool.title, rect.x+2, rect.y+15);

		}
	}
	public ToolPanel click(Point p, DrawPanel drawPanel){
		active = false;
		for(int i=0; i<tools.size(); i++){
			if (bboxs[i].contains(p)){
				ToolPanel toolPanel= (ToolPanel) tools.elementAt(i);
				toolPanel.open(drawPanel, p);
				return toolPanel;
			}
		}
		return null;
	}
	
	
}
