package board;

import java.util.*;
import java.awt.*;


public class View
{
	
	Record record;
	public View(Record record){
		this.record = record;
	}
	
	int position = 0;
	static final int W = 40;
	
	Vector visible_strokes = new Vector();
										
	public void paint(Graphics g){
		//int height = 740;
		
		visible_strokes = get_visible_strokes();

		g.setColor(Color.lightGray);
		g.fillRect(1024-W, 0, 1024, 768);
		
		
		g.setColor(Color.black);
		for(int i=0; i<visible_strokes.size(); i++){
			Stroke stroke = (Stroke)visible_strokes.elementAt(i);
			stroke.shifted_paint(g, 0, -position);
		}
		
	}	
	public Vector get_visible_strokes(){
		int height = 740;
		
		Vector strokes = record.getStrokes();
		Vector visible_strokes = new Vector();
		
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke)strokes.elementAt(i);
			if (stroke.bbox.y-position < height && stroke.bbox.y+stroke.bbox.height-position > 0){
				visible_strokes.addElement(stroke);
			}
		}
		return visible_strokes;
	}
	
	public Stroke get_screen_stroke(Stroke stroke){
		return stroke.shift_stroke_relative(0, -position);	
	}
	
	public void addStroke(Stroke stroke){
		record.addStroke(stroke.shift_stroke_relative(0, position));	
	}
	
}
