package tools;

import java.awt.event.*;
import java.awt.Rectangle;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Color;

import java.util.*;
import board.*;
import tools.calc.*;

public class HandCalcPanel extends ToolPanel
{
	static public final int WIDTH = 600;
	static public final int HEIGHT = 300;
	
	Vector strokes = new Vector();
	Vector old_strokes = new Vector();

	
	public HandCalcPanel(){
		title = "Handwrting Calculator";
	}
	
	public void open(DrawPanel drawPanel, Point p){
		super.open(drawPanel, new Rectangle(p.x-WIDTH/2, p.y-HEIGHT/2, WIDTH, HEIGHT)); 
		
		strokes = new Vector();
		old_strokes = new Vector();
		stroke = null;
	}
	
	public void paint_main(Graphics g){

		for(int i=0; i<old_strokes.size(); i++){
			Stroke stroke = (Stroke) old_strokes.elementAt(i);
			stroke.paint(g);
		}
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.paint(g);
		}
		if (stroke != null)
			stroke.paint(g);
		
	}
	
	
	
	
	Stroke stroke;
	public void start_stroke(Point p){
		stroke = new Stroke();
		stroke.color = Color.red;
		extend_stroke(p);
	}		
	public void extend_stroke(Point p){
		stroke.addPoint(p);
	}
	
	public void finish_stroke(Point p){
		if (stroke.length() < 10)
			return;

		strokes.addElement(stroke);
		
		String result = HandCalcMain.calculate(strokes);
		
		if (result != null){
		
			Rectangle bbox = get_strokes_bbox(strokes);
			int dy = bbox.height;
			Point pos = new Point(bbox.x+bbox.width+dy/8, bbox.y);
			
			strokes = Util.connectVector(strokes, Digits.get_strokes(result, pos, dy));
			
			
			for(int i=0; i<strokes.size(); i++){
				Stroke stroke = (Stroke) strokes.elementAt(i);
				stroke.color = Color.black;
				old_strokes.addElement(stroke);
			}
			
			strokes = new Vector();
			
			
		}
	}
	public Rectangle get_strokes_bbox(Vector strokes){
		Rectangle bbox = null;
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			if (bbox == null)
				bbox = stroke.bbox;
			else
				bbox = bbox.union(stroke.bbox);
		}
		return bbox;
	}

	
	
	
	
	
	
	
	
	
	
	
	
	public void mousePressed_content(MouseEvent e){
		start_stroke(e.getPoint());
	}
	public void mouseDragged_content(MouseEvent e){
		extend_stroke(e.getPoint());
	}
	public void mouseReleased_content(MouseEvent e){
		finish_stroke(e.getPoint());
	}	
	
	
	public void close(){
		flush_strokes(old_strokes);
	}
	public void flush_strokes(Vector strokes){
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.move_relative(content_bbox.x, content_bbox.y);
			drawPanel.view.addStroke(stroke);
		}
	}
	
	
}


