package tools;

import java.awt.event.*;

import java.awt.Rectangle;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Color;

import java.util.*;
import board.*;

public class PegasusPanel extends ToolPanel
{
	static public final int WIDTH = 600;
	static public final int HEIGHT = 300;
	
	Vector strokes = new Vector();

	
	
	public PegasusPanel(){
		title = "2D Line Drawing";
	}
	
	public void open(DrawPanel drawPanel, Point p){
		super.open(drawPanel, new Rectangle(p.x-WIDTH/2, p.y-HEIGHT/2, WIDTH, HEIGHT)); 
		
		strokes = new Vector();
		stroke = null;
		
		candidates = new Vector();
	}
	
	
	
	
	
	public void paint_main(Graphics g){

		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.paint(g);
		}
		for(int i=0; i<candidates.size(); i++){
			Stroke stroke = (Stroke) candidates.elementAt(i);
			stroke.paint(g);
		}
		if (primary != null)
			primary.paint(g);
		
		if (stroke != null)
			stroke.paint(g);
		
	}
	
	
	
	
	
	
	
	

	
	Stroke stroke;
	public void start_stroke(Point p){
		stroke = new Stroke();
		stroke.color = Color.red;
		extend_stroke(p);
	}		
	public void extend_stroke(Point p){
		stroke.addPoint(p);
	}
	
	public void finish_stroke(Point p){
		finish_stroke(stroke);
		stroke = null;
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public void mousePressed_content(MouseEvent e){
		start_stroke(e.getPoint());
	}
	public void mouseDragged_content(MouseEvent e){
		extend_stroke(e.getPoint());
	}
	public void mouseReleased_content(MouseEvent e){
		finish_stroke(e.getPoint());
	}	

	
	
	
	
	public void close(){
		flush_strokes(strokes);
	}
	public void flush_strokes(Vector strokes){
		finish_selection(primary);

		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.move_relative(content_bbox.x, content_bbox.y);
			drawPanel.view.addStroke(stroke);
		}
	}
	
	
	
	
	
	
	
	
	
	

	
	
	
	
	
	

	
	
	
	
	
	
	
	
	//
	//	main
	//
	
	public Vector getStrokes(){
		return strokes;
	}
	public void addStroke(Stroke stroke){
		strokes.addElement(stroke);
	}
	public void removeStroke(Stroke stroke){
		strokes.removeElement(stroke);
	}
	
	
    public void finish_stroke(Stroke stroke) {    
		double l =  stroke.length();
		double d = stroke.direct_length();

		// Click!
		if (l < 10)
			click(stroke);
		else if (l/d > 1.5)
			erase(stroke);
		else
		    beautify(stroke);

	}
			
			
	public void click(Stroke stroke){
	    // Select!
	    if (candidates.size() > 0){
		Stroke closest = pegasus.ForFlatland.get_closest(
				candidates, stroke.getPoint(0));

		if (closest != null)
		    if (predicting){
			// Settle and next prediction
			finish_selection(closest);
			predict(closest);
		    }
		    else {
			// Change the primary
			change_the_primary(closest);
		    }
		else{
		    if (predicting){
			// Cancel predictions
			cancel_prediction();
		    }
		    else{
			// Settle and predict

	    		// settle down the primary
	    		finish_selection(primary);
			predict(primary);
		    }
		}

	    }
	    // No candidates -> Predict!
	    else {;
		Stroke closest = pegasus.ForFlatland.get_closest(
				getStrokes(), stroke.getPoint(0));
		if (closest != null){
			// new Prediction
			predict(closest);
		}
	    }
	    return;

    }

	public void erase(Stroke stroke){
		
		// settle down the primary
		if (candidates.size() > 0){
		    finish_selection(primary);
			primary = null;
			predicting = false;
		}
	
		Stroke closest = pegasus.ForFlatland.get_closest(
				getStrokes(), stroke.getPoint(0));		

		if (closest == null)
			return;
		
		for(int i=0; i<strokes.size(); i++){
			Stroke s = (Stroke) strokes.elementAt(i);
			if (pegasus.ForFlatland.equals(s, closest))
				strokes.removeElement(s);
		}
	}









    // Behavior specific strokes
    Vector candidates;
    Stroke primary;
    boolean predicting;









    // atomic operations for undo/redo

    public void finish_selection(Stroke stroke){

		if (stroke != null){
			Stroke new_stroke = stroke.get_duplicated();
			new_stroke.setColor(Color.black);
			addStroke(new_stroke);
		}
		if (candidates.size() >0){

		    if (primary != null)
			removeStroke(primary);

			candidates = new Vector();
		}
    }

    public void beautify(Stroke stroke){

	    // settle down the primary
	    finish_selection(primary);

	    Stroke temp_primary = new Stroke();
	    Vector temp_candidates = new Vector();

	    pegasus.ForFlatland.beautify_self(
			stroke, getStrokes(), temp_candidates, temp_primary);

	    temp_primary.setColor(Color.red);

	    candidates = temp_candidates;
	    primary = temp_primary;
	    predicting = false;

    }
    public void change_the_primary(Stroke closest){
	    closest.setColor(Color.red);

	    //segment.changeStroke(primary, closest);
		primary = closest;
    }

    public void predict(Stroke triger){

		Vector temp_candidates = new Vector();

		pegasus.ForFlatland.get_predictions(
		    triger, getStrokes(), temp_candidates);

		candidates = temp_candidates;

		if (candidates.size() > 0){
			predicting = true;
		}
		else{
			predicting = false;
		}

		primary = null;
    }


    public void cancel_prediction(){
		for(Enumeration e=candidates.elements(); e.hasMoreElements();)
			removeStroke((Stroke) e.nextElement());

		candidates = new Vector();
		predicting = false;

    }
	
}


