package tools;

import java.awt.event.*;

import java.awt.Rectangle;
import java.awt.Point;
import java.awt.Graphics;
import java.awt.Color;

import java.util.*;
import board.*;

public class SamplePanel extends ToolPanel
{
	static public final int WIDTH = 300;
	static public final int HEIGHT = 300;
	
	public SamplePanel(){
		title = "Sample ToolPanel";
	}
	
	public void open(DrawPanel drawPanel, Point p){
		super.open(drawPanel, new Rectangle(p.x-WIDTH/2, p.y-HEIGHT/2, WIDTH, HEIGHT)); 
		strokes = new Vector();
		stroke = null;
	}
	
	
	
	
	
	public void paint_main(Graphics g){
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.paint(g);
		}
		if (stroke != null)
			stroke.paint(g);
	}
	
	
	
	
	
	
	
	

	
	Vector strokes = new Vector();
	
	Stroke stroke;
	public void start_stroke(Point p){
		stroke = new Stroke();
		stroke.color = Color.red;
		extend_stroke(p);
	}		
	public void extend_stroke(Point p){
		stroke.addPoint(p);
	}
	
	public void finish_stroke(Point p){
		// strokes.addElement(stroke);
		
		if (is_circle(stroke))
			strokes.addElement(get_circle(stroke));
		else
			strokes.addElement(get_line(stroke));
		
		stroke = null;
	}
	
	
	
	
	
	
	
	
	
	
	public void mousePressed_content(MouseEvent e){
		// boolean right_button = (e.getModifiers() & e.BUTTON3_MASK) != 0;	// E{^
		start_stroke(e.getPoint());
	}
	public void mouseDragged_content(MouseEvent e){
		extend_stroke(e.getPoint());
	}
	public void mouseReleased_content(MouseEvent e){
		finish_stroke(e.getPoint());
	}	

	
	
	
	
	public void close(){
		flush_strokes(strokes);
	}
	public void flush_strokes(Vector strokes){
		for(int i=0; i<strokes.size(); i++){
			Stroke stroke = (Stroke) strokes.elementAt(i);
			stroke.move_relative(content_bbox.x, content_bbox.y);
			drawPanel.view.addStroke(stroke);
		}
	}
	
	





	
	// 
	// specialized code below
	//
	
	
	
	
	public boolean is_circle(Stroke stroke){
		double l =  stroke.length();
		double d = stroke.direct_length();
		return (l/d > 2);
	}
	
	public Stroke get_circle(Stroke stroke){
		Point center = stroke.get_center();
		double radius = 0;
		for(int i=0; i<stroke.points.size(); i++){
			radius += Vertex2D.distance(center, (Point)stroke.points.elementAt(i));
		}
		radius /= stroke.points.size();
		
		Stroke new_stroke = new Stroke();
		for(int i=0; i<=20; i++){
			new_stroke.addPoint( (int)(center.x + radius * Math.cos(Math.PI*2*i/20)),
							 (int)(center.y + radius * Math.sin(Math.PI*2*i/20)));
		}
		
		return new_stroke;
	}
	
	public Stroke get_line(Stroke stroke){
		Point p = stroke.firstPoint();
		Point q = stroke.lastPoint();
		Stroke new_stroke = new Stroke();
		new_stroke.addPoint(p);
		new_stroke.addPoint(q);
		return new_stroke;
	}	
	
	
}


